/*
Date: 27.03.2012
Author: Iaroslav Tverdokhlib
Complexity: O(N^2)
Score: 50
*/
#define _CRT_SECURE_NO_DEPRECATE
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <vector>
#include <queue>
#include <iostream>
#include <iterator>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <sstream>
#include <fstream>
#include <ctime>
#include <cstring>
#pragma comment(linker, "/STACK:66777216")
using namespace std;
#define pb push_back
#define ppb pop_back
#define pi 3.1415926535897932384626433832795028841971
#define mp make_pair
#define x first
#define y second
#define pii pair<int,int>
#define pdd pair<double,double>
#define INF 1000000000
#define FOR(i,a,b) for (int _n(b), i(a); i <= _n; i++)
#define FORD(i,a,b) for(int i=(a),_b=(b);i>=_b;i--)
#define all(c) (c).begin(), (c).end()
#define SORT(c) sort(all(c))
#define rep(i,n) FOR(i,1,(n))
#define rept(i,n) FOR(i,0,(n)-1)
#define L(s) (int)((s).size())
#define C(a) memset((a),0,sizeof(a))
#define VI vector <int>
#define ll long long

struct pnt {
	int x, y;
	pnt() : x(0), y(0) {}
	pnt(int _x, int _y) : x(_x), y(_y) {}
};
inline pnt operator -(const pnt &a, const pnt &b) {
	return pnt(a.x - b.x, a.y - b.y);
}
inline ll vec(const pnt &a, const pnt &b) {
	return (ll)a.x * b.y - (ll)a.y * b.x;
}
inline bool operator <(const pnt &a, const pnt &b) {
	if (a.x != b.x) return a.x < b.x; else
	return a.y < b.y;
}
int a,b,c,d,i,j,n,m,k,r,u;
pair<pnt, ll> up[100003], down[100003];
pair<bool, pair<pnt, ll> > mem[300006];
int before[100001];
inline void add(pair<pnt, ll> *v, int &n, pnt t) {
	bool is_up = (v == up);
	while (n > 1 && vec(v[n - 1].x - v[n - 2].x, t - v[n - 2].x) >= 0) {
		mem[r++] = mp(is_up, v[n - 1]);
		--n;
	}
	v[n].x = t;
	if (!n) v[n].y = 0; else
	v[n].y = v[n - 1].y + vec(v[n - 1].x, t);
	++n;
}
inline void rollback() {
	--r;
	if (mem[r].x == 0) {
		down[d++] = mem[r].y;
	} else {
		up[u++] = mem[r].y;
	}
}

pnt st[100001];
inline ll get_s(pair<pnt, ll> *v, int n) {
	if (n < 3) return 0;
	ll ans = v[n - 1].y + vec(v[n - 1].x, v[0].x);
	if (ans < 0) ans = -ans;
	return ans;
}

int main() {
	freopen("convex.dat","r",stdin);
	freopen("convex.sol","w",stdout);
	scanf("%d", &n);
	k = 0;
	ll s = 0;
	rept(i, n) {
		scanf("%d", &a);
		a = (a + s) % 2;
		if (a == 0) {
			scanf("%d%d", &b, &c);
			int lx = -INF;
			if (u) lx = up[u - 1].first.x;
			b = lx + (s + b) % (2 * INF + 1);
			c = (s + c) % (2 * INF + 1) - INF;
			
			before[m++] = r;
			add(up, u, pnt(b, c));
			add(down, d, pnt(b, -c));
		} else {
			scanf("%d%d", &b, &c);
			b = (s + c + b) % m + 1;
			rept(j, b) {
				--d; --u; --m;
				while (r != before[m]) {
					rollback();
				}
			}
		}
		s = get_s(up, u) + get_s(down, d);
		printf("%lld\n", s);
	}
}
